function [dy]=backwardy_nb(u)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Backward difference operator in the y-direction for the input
% matrix u, which is assumed to be buffered (layer thickness 2).
% Periodic boundary conditions used.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Uses: upbuffer2.m
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

u = padnb(u,2);
[m,n]=size(u);	% Buffered size.
m=m-4;		% Find the unbuffered size.
n=n-4;		% Find the unbuffered size.

dy=u;		% Initialization for dy.

% Carry out the operation on unbuffered part of u: 
dy(3:m+2,3:n+2)=( u(3:m+2,3:n+2) - u(2:m+1,3:n+2) );

% Update the buffer region:
dy=upbuffer2nb(dy);

dy = dy(3:m+2,3:n+2); %extract unbuffered region






