function [ubo]=upadnb(ub,L)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% This function updates the buffer layer of a buffered matrix, 
% using homog neumann (reflection) bc, where the buffer layer thickness is L. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Notes: No error checking is built in. Make sure size of input
%	 matrix is large enough: both dims. > 4 needed.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

m=size(ub,1)-2*L;
n=size(ub,2)-2*L;

%m
%n

% Update the buffer:

%neumann 2
%ub(3:m+2,1:2)=ub(3:m+2,5:-1:4);
%ub(3:m+2,n+3:n+4)=ub(3:m+2,n+3:-1:n+2);
%ub(1:2,1:n+4)=ub(5:-1:4,1:n+4);
%ub(m+3:m+4,1:n+4)=ub(m+3:-1:m+2,1:n+4);

%neumann 1

%left reflect
ub(L+1:L+m,1:L)= ub(L+1:L+m,L+L:-1:L+1);

%right reflect
ub(L+1:L+m,L+n+1:L+n+L)= ub(L+1:L+m,L+n:-1:L+n-L+1);


%top reflect
ub(1:L,1:n+2*L)= ub(L+L:-1:L+1,1:n+2*L);

%bottom reflect
ub(L+m+1:L+m+L,1:n+2*L)= ub(L+m:-1:L+m-L+1,1:n+2*L);



%ub(3:m+2,n+3:n+4)=ub(3:m+2,n+2:-1:n+1);
%ub(1:2,1:n+4)=ub(4:-1:3,1:n+4);
%ub(m+3:m+4,1:n+4)=ub(m+2:-1:m+1,1:n+4);




% previous periodic bc
%ub(3:m+2,1:2)=ub(3:m+2,n+1:n+2);
%ub(3:m+2,n+3:n+4)=ub(3:m+2,3:4);
%ub(1:2,1:n+4)=ub(m+1:m+2,1:n+4);
%ub(m+3:m+4,1:n+4)=ub(3:4,1:n+4);

ubo=ub;
